From 19cb7855b265bd2d9b6ae07a0ca4884c64c27073 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Aug 30 2020 07:05:55 +0000
Subject: [PATCH 759/2232] Use GeneratedCode consistently as return type for pair of files


---

diff --git a/gen/lib/src/lib.rs b/gen/lib/src/lib.rs
index d2ac1ca..d707529 100644
--- a/gen/lib/src/lib.rs
+++ b/gen/lib/src/lib.rs
@@ -7,19 +7,11 @@
 mod gen;
 mod syntax;
 
-pub use crate::gen::Opt;
+pub use crate::gen::{GeneratedCode, Opt};
 use proc_macro2::TokenStream;
 use std::error::Error as StdError;
 use std::fmt::{self, Debug, Display};
 
-/// Results of code generation.
-pub struct GeneratedCode {
-    /// The bytes of a C++ header file.
-    pub header: Vec<u8>,
-    /// The bytes of a C++ implementation file (e.g. .cc, cpp etc.)
-    pub cxx: Vec<u8>,
-}
-
 pub struct Error(crate::gen::Error);
 
 /// Generate C++ bindings code from a Rust token stream. This should be a Rust
@@ -28,10 +20,7 @@ pub fn generate_header_and_cc(rust_source: TokenStream, opt: &Opt) -> Result<Gen
     let syntax = syn::parse2(rust_source)
         .map_err(crate::gen::Error::from)
         .map_err(Error)?;
-    match gen::generate(syntax, opt, true, true).map_err(Error)? {
-        (Some(header), Some(cxx)) => Ok(GeneratedCode { header, cxx }),
-        _ => panic!("Unexpected generation"),
-    }
+    gen::generate(syntax, opt, true, true).map_err(Error)
 }
 
 impl Display for Error {
diff --git a/gen/src/mod.rs b/gen/src/mod.rs
index 0743939..ff0f736 100644
--- a/gen/src/mod.rs
+++ b/gen/src/mod.rs
@@ -47,6 +47,14 @@ pub struct Opt {
     pub cxx_impl_annotations: Option<String>,
 }
 
+/// Results of code generation.
+pub struct GeneratedCode {
+    /// The bytes of a C++ header file.
+    pub header: Vec<u8>,
+    /// The bytes of a C++ implementation file (e.g. .cc, cpp etc.)
+    pub cxx: Vec<u8>,
+}
+
 pub(super) fn do_generate_bridge(path: &Path, opt: &Opt) -> Vec<u8> {
     let header = false;
     generate_from_path(path, opt, header)
@@ -75,12 +83,8 @@ fn generate_from_string(source: &str, opt: &Opt, header: bool) -> Result<Vec<u8>
         source = &source[shebang_end..];
     }
     let syntax: File = syn::parse_str(source)?;
-    let results = generate(syntax, opt, header, !header)?;
-    match results {
-        (Some(hdr), None) => Ok(hdr),
-        (None, Some(cxx)) => Ok(cxx),
-        _ => panic!("Unexpected generation"),
-    }
+    let generated = generate(syntax, opt, header, !header)?;
+    Ok(if header { generated.header } else { generated.cxx })
 }
 
 pub(super) fn generate(
@@ -88,7 +92,7 @@ pub(super) fn generate(
     opt: &Opt,
     gen_header: bool,
     gen_cxx: bool,
-) -> Result<(Option<Vec<u8>>, Option<Vec<u8>>)> {
+) -> Result<GeneratedCode> {
     proc_macro2::fallback::force();
     let ref mut errors = Errors::new();
     let bridge = syntax
@@ -106,15 +110,16 @@ pub(super) fn generate(
     // Some callers may wish to generate both header and C++
     // from the same token stream to avoid parsing twice. But others
     // only need to generate one or the other.
-    let hdr = if gen_header {
-        Some(write::gen(namespace, apis, types, opt, true).content())
-    } else {
-        None
-    };
-    let cxx = if gen_cxx {
-        Some(write::gen(namespace, apis, types, opt, false).content())
-    } else {
-        None
-    };
-    Ok((hdr, cxx))
+    Ok(GeneratedCode {
+        header: if gen_header {
+            write::gen(namespace, apis, types, opt, true).content()
+        } else {
+            Vec::new()
+        },
+        cxx: if gen_cxx {
+            write::gen(namespace, apis, types, opt, false).content()
+        } else {
+            Vec::new()
+        },
+    })
 }

